Public Structure Sample : Implements IComparable
    '  
    Public Sub New(ByVal nData As Integer)
        keyMember = nData
    End Sub
    '     
    Public keyMember As Integer
    '  - ...  

    '  IComparable
    '  ,     
    '  ,     
    ' ,     
    Public Function CompareTo(ByVal obj As Object) As Integer Implements System.IComparable.CompareTo
        Try
            Return Math.Sign(keyMember - CType(obj, Sample).keyMember)
        Catch
            '-    
        End Try
    End Function
End Structure
Public Structure Sample2
    '  
    Public Sub New(ByVal nData As Integer)
        keyMember = nData
    End Sub
    '     
    Public keyMember As Integer
    '  - ...  
End Structure

'      Sample2
Public Class Sample2Sorter : Implements IComparer
    '  , x  y
    '  ,  x  y
    ' ,  x  y
    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
        Try
            Return Math.Sign(CType(x, Sample2).keyMember - CType(y, Sample2).keyMember)
        Catch
        End Try
    End Function
End Class

Public Module TestSorting
    '       IComparable
    Public Sub Test1()
        Dim arr() As Sample = {New Sample(10), New Sample(9), New Sample(-2), New Sample(29), New Sample(0)}
        Dim s As Sample
        Console.WriteLine("Before sorting")
        For Each s In arr
            Console.WriteLine(s.keyMember)
        Next
        Array.Sort(arr)
        Console.WriteLine("After sorting")
        For Each s In arr
            Console.WriteLine(s.keyMember)
        Next
    End Sub
    '       IComparer
    Public Sub Test2()
        Dim arr() As Sample2 = {New Sample2(10), New Sample2(9), New Sample2(-2), New Sample2(29), New Sample2(0)}
        Dim s As Sample2
        Console.WriteLine("Before sorting")
        For Each s In arr
            Console.WriteLine(s.keyMember)
        Next
        Dim sorter As New Sample2Sorter()
        Array.Sort(arr, sorter)
        Console.WriteLine("After sorting")
        For Each s In arr
            Console.WriteLine(s.keyMember)
        Next
    End Sub
End Module
